#include "run.h"
#include "buffer.h"
#include "alloc.h"
#include "gen_allocdefs.h"
#include "strerr.h"
#include "sml.h"

GEN_ALLOC_ready(Runs,Run,s,len,a,i,n,x,10000,Runs_ready)
GEN_ALLOC_readyplus(Runs,Run,s,len,a,i,n,x,10000,Runs_readyplus)
GEN_ALLOC_append(Runs,Run,s,len,a,i,n,x,10000,Runs_readyplus,Runs_append)

static void
put(char c)
{
    if (c >= ' ' && c != '\\') {
	if (buffer_put(buffer_1, &c, sizeof c) < 0)
	    strerr_die1sys(1, "write");
    }

    else {
	char s[4];
	s[0] = '\\';
	s[1] = '0' + ((c >> 6) & 3);
	s[2] = '0' + ((c >> 3) & 7);
	s[3] = '0' + (c & 7);
	if (buffer_put(buffer_1, s, sizeof s) < 0)
	    strerr_die1sys(1, "write");
    }
}

void
Runs_dump(void)
{
    char *p;
    int i, nruns, j;

    nruns = markup.len;
    p = chars.s;
    for (i = 0; i < nruns; i++) {
	Context_dump(markup.s[i].x);
	put('<');
	for (j = markup.s[i].len; j > 0; --j) {
	    put(*p++);
	}
	if (buffer_put(buffer_1, ">\n", 2) < 0)
	    strerr_die1sys(1, "write");
    }

    buffer_flush(buffer_1);
}

